function resize()
{
    var header = 57;
    var footer = 18;
    var panel = 41;
    var drilldown = 11;
    var backside = 169;

    var w = 218;
    var h = header + footer;
    
    if($('update').style.display == "block")
        h += panel;
    
    var multiview_on = $('multibox').checked;
    for(var i = 0; i < 4; i++)
    {
        if(gradesShown[i] == true) h += panel;
        else if(multiview_on) h += drilldown;
    }
        
    if(h < backside) h = backside;
    
    if($('pole').style.display == "block")
        h = screen.height;

    window.resizeTo(w,h);
}

function spinPrice()
{
    var station = (stationList) ? stationList[rankShown-1] : null;
    
    for(var i = 0; i < 4; i++)
    {
		for(var j = 0; j < 3; j++)
			clearTimeout(gradeTimers[i][j]);

        if(gradesShown[i])
        {
            var gradeDIV = $(gradeList[i]);
            
            var color = (station == null || !$("colorbox").checked) ? yellow : station.colors[i];
			
            var spinner = 'images/numbers/spin'+color+'.gif';
            spinner = spinner.replace(/#/,'_');
            
            getSubelementById(gradeDIV, 'digit1').src = spinner;
			// setTimeout(
			// 	function(div, spinner) {
			// 		getSubelementById(div, 'digit2').src = spinner;
			// 	} , 100, gradeDIV, spinner);
			// 	
			// setTimeout(
			// 	function(div, spinner) {
			// 		getSubelementById(div, 'digit3').src = spinner;
			// 	} , 200, gradeDIV, spinner);
			
			getSubelementById(gradeDIV, 'digit2').src = spinner;
            getSubelementById(gradeDIV, 'digit3').src = spinner;
            getSubelementById(gradeDIV, 'cell4').style.background = color;
        }
    }
}

function switchColorset(set)
{
    colorset = set;
        
    $("header").style.background = "url('images/" + colorset + "/header.png')";
    $("footer").style.background = "url('images/" + colorset + "/footer.png')";
    $("regular").style.background = "url('images/" + colorset + "/panel.png')";
    $("plus").style.background = "url('images/" + colorset + "/panel.png')";
    $("premium").style.background = "url('images/" + colorset + "/panel.png')";
    $("diesel").style.background = "url('images/" + colorset + "/panel.png')";
    $("regularDrilldown").style.background = "url('images/" + colorset + "/drilldown.png')";
    $("plusDrilldown").style.background = "url('images/" + colorset + "/drilldown.png')";
    $("premiumDrilldown").style.background = "url('images/" + colorset + "/drilldown.png')";
    $("dieselDrilldown").style.background = "url('images/" + colorset + "/drilldown.png')";
    //$("update").style.background = "url('images/" + colorset + "/panel.png')";

    if(colorset == "bold" || colorset == "deep" || colorset == "black")
    {
    	changeCSSRule("A", "color", "#FFF");
    	changeCSSRule("A", "textShadow", "black 0px -1px 1px");
    	changeCSSRule("#label", "color", "#CCC");
    	changeCSSRule("#label", "textShadow", "black 0px -1px 1px");
    } else {
        changeCSSRule("A", "color", "#333");
    	changeCSSRule("A", "textShadow", "white 0px 1px 1px");
    	changeCSSRule("#label", "color", "#111");
    	changeCSSRule("#label", "textShadow", "#CCC 0px 1px 1px");
    }
    
    if(colorset == "white"){
    	$("flip").src = "file:///System/Library/WidgetResources/ibutton/black_i.png";
    }else{
    	$("flip").src = "file:///System/Library/WidgetResources/ibutton/white_i.png";
    }
    
    setPreferenceForKey(colorset, "colorset");
}

function updateSortGrade() {
	var gradeNum = $("sortnum").selectedIndex - 1;
    setPreferenceForKey(gradeNum, "sortnum");
	
	if(gradeNum < 0) gradeNum = 0;
    grade = gradeList[gradeNum];

    sortStations(grade);
    
    //update graphics
	for(var i = 0; i < 4; i++)
	{
		panelDIV = $(gradeList[i]);
		drilldownDIV = $(gradeList[i] + "Drilldown");
		
		gradeDIV = getSubelementById(panelDIV, "grade");
	
		if(i == gradeNum)
		{
			gradesShown[i] = true;
			
			gradeDIV.style.opacity = 1;
			panelDIV.style.display = "block";
			drilldownDIV.style.display = "none";
		} else {
			
			if(!multiviewing)
			{
				panelDIV.style.display = "none";
				gradesShown[i] = false;
			}
			
			gradeDIV.style.opacity = .5;
		}
	}
	
	if(!multigrade) performQuery();
	else if(stationList) stationList[rankShown-1].display();
}

function sortStations(grade)
{
	//sort stations; bubblesort because the list should be mostly sorted already
    if(stationList && stationList.length > 1) do
    {
    	var swaps = 0;
        for(var i = 0; i < stationList.length - 1; i++)
        {
            if(stationList[i].priceForGrade(grade) > stationList[i+1].priceForGrade(grade))
            {
            	var tmp = stationList[i];
            	stationList[i] = stationList[i+1];
            	stationList[i+1] = tmp;
            	stationList[i].rank--;
            	stationList[i+1].rank++;
            	swaps++;
            }
        }
    } while(swaps > 0)
}

var rivet = new Image(6, 6);
rivet.src = "images/rivet.png";

var needle = new Image(8, 92);
needle.src = "images/needle.png";

var needle_shadow = new Image(12, 100);
needle_shadow.src = "images/needle_shadow.png";

var needle_small = new Image(4, 28);
needle_small.src = "images/needle_small.png";

var needle_shadow_small = new Image(8, 31);
needle_shadow_small.src = "images/needle_shadow_small.png";

var gaugeAnimation = null;

function startGauge()
{
	gaugeAnimation = setInterval("drawGauge();", 50);
	setGauge($("gas_slider").value/100);
}

function stopGauge()
{
	clearInterval(gaugeAnimation);
}

var fuel = 0;
var cost = 0;
var value = 0;

var fuel_t = 0;
var cost_t = 0;
var value_t = 0;

function setGauge(f)
{
	fuel_t = f;
	cost_t = f;
	value_t = 1-f;
	
	var tank = $('tank').value;
	var mpg = $('mpg').value;
	
	//get price for current station/grade
	var price = stationList[rankShown-1].priceForGrade(gradeList[$("sortnum").selectedIndex-1]);
	if(price == "n.sp") price = "0";
	
	//get avg price for grade in area
	var avgPrice = avgPriceForGrade(gradeList[$("sortnum").selectedIndex-1]);
	if(!avgPrice) avgPrice = price;
	var valuedSavings = 3.00;  //span of the value meter
	
	cost_t = ((1-f)*tank*price)/100;
	value_t = (price == "0") ? 0 : Math.min((avgPrice - price)*(1-f)*tank/valuedSavings, 1);
	
	//set mileage
	var miles = ((tank*mpg)*f + .0001).toString();
	var match = miles.match(/(\d*).(\d)/);
	miles_int = match[1];
	miles_frac = match[2];
	while(miles_int.length < 4) miles_int = '0' + miles_int;
	miles_string = miles_int + "<font color='#0'> " + miles_frac + "</font>";
	$("miles").innerHTML = miles_string;
	
	drawGauge();
	
	if(tank !== ""){setPreferenceForKey(tank, "tank");}
	if(mpg !== ""){setPreferenceForKey(mpg, "mpg");}
}

function saveRangePref(){
	var full = $('gas_slider').value;
	setPreferenceForKey(full, "full");
}

function drawGauge()
{
    //update rotations
    fuel += (fuel_t - fuel)*.2;
    cost += (cost_t - cost)*.05;
    value += (value_t - value)*.05;
    
    var canvas = $("gauge");
    var context = canvas.getContext("2d");
    
    context.clearRect(0, 0, 208, 78);
    
    //fuel meter
    context.save();
   		context.translate(106, 103);
    	context.save();
    		context.rotate(2.58 + 1.13*fuel);
    		context.drawImage(needle_shadow,-6, -6, 12, 100);
    	context.restore();
    	context.translate(0,-7)
    	context.save();
    		context.rotate(2.58 + 1.13*fuel);
    		context.drawImage(needle,-4, -4, 8, 92);
    	context.restore();
    context.restore();
    
    //cost meter
    context.save();
    	context.translate(36, 62);
    	context.save();
    		context.rotate(.52 + 5.25*cost);
    		context.drawImage(needle_shadow_small,-4, -4, 8, 31);
    	context.restore();
    	context.translate(0,-6);
    	context.save();
    		context.rotate(.52 + 5.25*cost);
    		context.drawImage(needle_small,-2, -2, 4, 28);
    	context.restore();
    	context.drawImage(rivet,-3, -3, 6, 6);
    context.restore();
    
    //value meter
	context.save();
   		context.translate(179, 62);
    	context.save();
    		context.rotate(3.14 + 2.09*value);
    		context.drawImage(needle_shadow_small,-4, -4, 8, 31);
    	context.restore();
    	context.translate(0,-6)
    	context.save();
    		context.rotate(3.14 + 2.09*value);
    		context.drawImage(needle_small,-2, -2, 4, 28);
    	context.restore();
    	context.drawImage(rivet,-3, -3, 6, 6);
    context.restore();
}

function clearAttr(logo)
{
	$("attr").innerText = "";
	$("attrTo").innerText = "";
	$(logo).src = "images/" + logo + ".png";
}

function setAttr(attr, to, logo)
{
	$("attr").innerText = attr;
	$("attrTo").innerText = to;
	$(logo).src = "images/" + logo + "_color.png";
}

function changeLabel(label)
{
	$('label').innerHTML= (label) ? label : '&nbsp;';
	setPreferenceForKey(label, "label");
}